# Grafana Chartwerk Panel (beta)

<p align="center"><img src="https://code.corpglory.net/chartwerk/grafana-chartwerk-panel/raw/branch/main/src/assets/logo.svg" width="150" height="150" /></div>

**Grafana Chartwerk Panel** renders metrics using Chartwerk libraries. For now, it can render as Gauge. We are working on adding new visualizations.

![image](https://code.corpglory.net/chartwerk/grafana-chartwerk-panel/raw/branch/main/src/assets/img/gauge.png)

## Features

- 3 types of visualizations:
  - Gauge
  - Line Chart (coming soon)
  - Bar Chart (coming soon)
- Gauge: dynamic thresholds and min / max
- Gauge: conditional icons displaying
- Gauge: reversed direction

## How to use

1. Create a new panel and select Chartwerk as the visualization
2. Add queries with unique aliases
3. Go to the Options Tab and setup panel:

- Choose visualization type
- Select metric in the Value -> Metric dropdown (by default, the first metric is used)

## Options [Gauge]

- Visualization:
  - Pod: option to select chart type
- Value:
  - Metric: select metric query from dropdown
- Extemum:
  - Min:
    - type number for static minimum value OR
    - enable "Use metric" toggle switch to select metric as minimun
    - default value: 0
  - Max:
    - type number for static maximum OR
    - enable "Use metric" toggle switch to select metric as maximum
    - default value: maximum of metric query

## Installation

### Linux / Mac OS X

- Navigate to either:

  - `<GRAFANA_PATH>/data/plugins` (when installed from tarball or source)
  - or `/var/lib/grafana/plugins` (when installed from `.deb`/`.rpm` package)

- Download Chartwerk panel

```
wget -O corpglory-chartwerk-panel-0.5.1.zip https://code.corpglory.net/attachments/4ab21067-0618-42de-8c9e-04ebfe114b39
```

- Unpack downloaded files

```
unzip -u corpglory-chartwerk-panel-0.5.1.zip
```

- Restart grafana-server
  - For grafana installed via Standalone Linux Binaries:
    - Stop any running instances of grafana-server
    - Start grafana-server by:
      `$GRAFANA_PATH/bin/grafana-server`
  - For grafana installed via Package Manager:
    - type in `systemctl restart grafana-server`

### Grafana in Docker

You can install Chartwerk panel to Grafana in Docker passing it as environment variable (as described in [Grafana docs](http://docs.grafana.org/installation/docker/#installing-plugins-from-other-sources))

```bash
docker run \
  -p 3000:3000 \
  -e "GF_INSTALL_PLUGINS=https://code.corpglory.net/attachments/4ab21067-0618-42de-8c9e-04ebfe114b39;corpglory-chartwerk-panel" \
  grafana/grafana
```

## Demo

see [demo](https://grafana.corpglory.com/d/8vGyMypGz/demo-home?orgId=4)
